package com.liang.service;

import com.liang.entity.StaIntellectualProperty;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 知识产权费(StaIntellectualProperty)表服务接口
 */
public interface StaIntellectualPropertyService {
    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaIntellectualProperty queryById(Integer id);

    /**
     * 分页查询
     *
     * @param staIntellectualProperty 筛选条件
     * @param pageRequest             分页对象
     * @return 查询结果
     */
    Page<StaIntellectualProperty> queryByPage(StaIntellectualProperty staIntellectualProperty, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param staIntellectualProperty 实例对象
     * @return 实例对象
     */
    int insert(StaIntellectualProperty staIntellectualProperty);

    /**
     * 修改数据
     *
     * @param staIntellectualProperty 实例对象
     * @return 实例对象
     */
    int update(StaIntellectualProperty staIntellectualProperty);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除知识产权费
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

    /**
     * 批量插入知识产权费
     *
     * @param expenseList
     * @return
     */
    int insertBatch(List<StaIntellectualProperty> expenseList);

    /**
     * 获取知识产权费列表
     *
     * @return
     */
    List<StaIntellectualProperty> getZscqfList(Integer zb);

    List<StaIntellectualProperty> queryByKyfh(String kyfh);

    /**
     * 统计报表（知识产权费）查询
     *
     * @param xmmc 项目名称
     * @param cqlb 产权类别
     * @param mc   名称
     * @param wtjg 委托机构
     * @param qsrq 创建起始日期
     * @param jzrq 创建结束日期
     * @return
     */
    List<HashMap<String, Object>> searchIntellectualCost(Map map);
}
